<?php

$guns = array(
/*
1. кулак, бензопила: 2-20
2. пистолет   [1] : 5-15
3. дробовик   [1] : 35-105
3. двустволка [2] : 100-300
4. пулемёт    [1] : 5-15 с пули
5. ракетомёт  [1] : 20-160 (поражаются все на локации, повреждения 0-128)
6. плазмоган  [1] : 5-40 с пули
7. BFG9000    [40]: 100-800 (поражаются все на локации и далее, повреждения 49-87)

1. пули 2, 4: 200
2. пули 3   : 50
3. пули 5   : 50
4. пули 6, 7: 300
*/

# бензопила
'gun0' => array(
    'name'          => 'бензопила',
    'bullet'        => '',      # тип используемых патронов (0 — автономно)
    'rate'          => 0,       # расход патронов за выстрел
    'time'          => 1,       # время перезарядки (кратное одному тику игры)
    'damage'        => array(2,20),  # повреждения
    'nouse'         => 1,       # установлен, если предмет нельзя снять с трупа
    'noranged'      => 1,       # установлен, если допускается использование только в текущей локации
    'recharge'      => 0,       # время последней перезарядки
),

# пистолет
'gun1' => array(
    'name'          => 'пистолет',
    'bullet'        => 'bullet',
    'rate'          => 1,
    'time'          => 1,
    'damage'        => array(5,15),
    'charger'       => 10,      # патронов в магазине
    'recharge'      => 0,
),

# дробовик
'gun2' => array(
    'name'          => 'дробовик',
    'bullet'        => 'shot',
    'rate'          => 1,
    'time'          => 2,
    'damage'        => array(35,105),
    'charger'       => 6,
    'recharge'      => 0,
),

# двустволка
'gun3' => array(
    'name'          => 'двустволка',
    'bullet'        => 'shot',
    'rate'          => 2,
    'time'          => 3,
    'damage'        => array(70,210),
    'charger'       => 2,
    'recharge'      => 0,
),

# пулемёт
'gun4' => array(
    'name'          => 'пулемёт',
    'bullet'        => 'bullet',
    'rate'          => 5,
    'time'          => 1,
    'damage'        => array(25,75),
    'charger'       => 30,
    'recharge'      => 0,
),

# ракетница
'gun5' => array(
    'name'          => 'ракетница',
    'bullet'        => 'rocket',
    'rate'          => 1,
    'time'          => 2,
    'damage'        => array(20,160),
    'add_damage'    => array(0,128), # дополнительные повреждения, которые получаю все в текущей локации
    'self_damage'   => 1,       # 1, если повреждения может получить игрок, который стреляет (только если существует add_damage)
    'charger'       => 1,
    'recharge'      => 0,
),

# плазма-ган
'gun6' => array(
    'name'          => 'плазма-ган',
    'bullet'        => 'power',
    'rate'          => 5,
    'time'          => 1,
    'damage'        => array(25,125),
    'charger'       => 25,
    'recharge'      => 0,
),

# бфг
'gun7' => array(
    'name'          => 'BFG9000',
    'bullet'        => 'power',
    'rate'          => 40,
    'time'          => 3,
    'damage'        => array(100,250),
    'add_damage'    => array(49,87),
    'charger'       => 40,
    'recharge'      => 0,
),

);
