<?php
require 'header.php';

if (empty($_SESSION[SESNAME])) { # если пользователь не авторизован, выход
    header('Location: index.php?' . SESNAME . '=' . SESID . '&' . rand());
    exit;
}

define('FORUM', DIR . '#forum' . DS); # сохранёнки форума

$params = array();

$user = unserialize(file_get_contents(USERS . $_SESSION[SESNAME]['name'] . '.dat'));

# получаем список разделов
foreach (file(FORUM . 'razdel.dat') as $v) {
    $v = trim($v);
    if (empty($v)) continue;
    $t = explode('|', $v, 2);
    $board[$t[0]] = $t[1]; # админ сам должен учитывать и заменять на мнемоники <>&"
}

$params['board'] = $board;

if (empty($_GET['board'])) {
    $content .= get_content('forum'.DS.'board', $params);
} else {
    $params['id_board'] = (int) $_GET['board'];
    $file = FORUM . 'board' . $params['id_board'] . '.dat';
    
    if (empty($_GET['theme'])) {
        if (isset($_GET['new'])) { # новая тема
            if ( ! empty($_POST)) {
                $err = array();
                if ( ! empty($_POST['theme'])) $_POST['theme'] = trim($_POST['theme']);
                if (empty($_POST['theme'])) $err['theme'] = 1;
                if ( ! empty($_POST['message'])) $_POST['message'] = trim($_POST['message']);
                if (empty($_POST['message'])) $err['message'] = 1;
            }
            
            if (empty($_POST) || ! empty($err)) {
                if (isset($err)) $params['err'] = $err;
                $content .= get_content('forum'.DS.'add_theme', $params);
            } else {
                $fn = fopen($file, 'r+');
                flock($fn, LOCK_EX);
                fseek($fn, 0);
                $themes = unserialize(fread($fn, filesize($file)));
                fseek($fn, 0);
                ftruncate($fn, 0);
                
                $id = $themes['cnt']++;
                $ntheme = array(
                    'user'    => $user->login,
                    'uname'   => $user->name,
                    'time'    => ITIME, # время создания темы
                    'ltime'   => ITIME, # время последнего редактирования (добавление сообщения)
                    'name'    => htmlspecialchars($_POST['theme']),
                    'cnt_mes' => 1, # кол-во сообщений
                );
                $themes['datas'][$id] = $ntheme;
                
                # добавляем первое сообщение
                $messages = array(
                    'cnt'   => 2,
                    'theme' => htmlspecialchars($_POST['theme']),
                    'datas' => array(
                        '1'   => array(
                            'id'   => 1,
                            'user' => $user->login,
                            'name' => $user->name,
                            'time' => ITIME,
                            'mes'  => nl2br(htmlspecialchars($_POST['message']))
                        ),
                    )
                );
                file_put_contents(FORUM . 'board' . $params['id_board'] . '_theme' . $id . '.dat', serialize($messages));
                
                fwrite($fn, serialize($themes));
                flock($fn, LOCK_UN);
                fclose($fn);
                
                header('Location: ?board='.$params['id_board'].'&'.rand());
                exit;
            }
        } else { # 
            if ( ! file_exists($file)) file_put_contents($file, serialize(array('cnt'=>1, 'datas' => array())));
            $themes = unserialize(file_get_contents($file));
            $params['all_page'] = intval((count($themes['datas']) + $cfg['forum_theme'] - 1) / $cfg['forum_theme']);
            if ($params['all_page'] < 1) $params['all_page'] = 1;
            $params['page'] = isset($_GET['page']) ? (int) $_GET['page'] : 1;
            if ($params['page'] < 1) $params['page'] = 1;
            if ($params['page'] > $params['all_page']) $params['page'] = $params['all_page'];
            uasort($themes['datas'], 'themes_time_sort');
            $params['themes'] = array_slice($themes['datas'], ($params['page'] - 1) * $cfg['forum_theme'], $cfg['forum_theme'], TRUE);
            $content .= get_content('forum'.DS.'themes', $params);
        }
    } else {
        $theme = (int) $_GET['theme'];
        $params['id_theme'] = $theme;
        $file = FORUM . 'board' . $params['id_board'] . '_theme' . $params['id_theme'] . '.dat';
        
        if (isset($_GET['new'])) { # новое сообщение
            if ( ! empty($_POST)) {
                $err = array();
                if ( ! empty($_POST['message'])) $_POST['message'] = trim($_POST['message']);
                if (empty($_POST['message'])) $err['message'] = 1;
            }
            
            if (empty($_POST) || ! empty($err)) {
                if (isset($err)) $params['err'] = $err;
                $messages = unserialize(file_get_contents($file));
            } else {
                $fn = fopen($file, 'r+');
                flock($fn, LOCK_EX);
                fseek($fn, 0);
                $messages = unserialize(fread($fn, filesize($file)));
                fseek($fn, 0);
                ftruncate($fn, 0);
                
                # добавляем первое сообщение
                $id = $messages['cnt']++;
                $message = array(
                    'user' => $user->login,
                    'name' => $user->name,
                    'time' => ITIME,
                    'mes'  => nl2br(htmlspecialchars($_POST['message']))
                );
                $messages['datas'][$id] = $message;
                fwrite($fn, serialize($messages));
                
                //*
                # -- -----------------------------------------------------------
                # также требуется обновить время доступа в списке тем
                $fn1 = fopen(FORUM.'board'.$params['id_board'].'.dat', 'r+');
                flock($fn1, LOCK_EX);
                fseek($fn1, 0);
                $themes = unserialize(fread($fn1, filesize($file)));
                fseek($fn1, 0);
                ftruncate($fn1, 0);
                $themes['datas'][$params['id_theme']]['ltime'] = ITIME;
                $themes['datas'][$params['id_theme']]['cnt_mes']++;
                fwrite($fn1, serialize($themes));
                flock($fn1, LOCK_UN);
                fclose($fn1);
                # -- -----------------------------------------------------------
                /**/
                
                flock($fn, LOCK_UN);
                fclose($fn);
                
                header('Location: ?board='.$params['id_board'].'&theme='.$params['id_theme'].'&page='.intval((count($messages['datas']) + $cfg['forum_message'] - 1) / $cfg['forum_message']).'&'.rand());
                exit;
            }
        } else $messages = unserialize(file_get_contents($file));
        
        if ( ! file_exists($file)) {
            header('Location: ?board='.$params['id_board'].'&'.rand());
            exit;
        }
        
        $params['all_page'] = intval((count($messages['datas']) + $cfg['forum_message'] - 1) / $cfg['forum_message']);
        if ($params['all_page'] < 1) $params['all_page'] = 1;
        $params['page'] = isset($_GET['page']) ? (int) $_GET['page'] : 1;
        if ($params['page'] < 1) $params['page'] = 1;
        if ($params['page'] > $params['all_page']) $params['page'] = $params['all_page'];
        
        $params['messages'] = array_slice($messages['datas'], ($params['page'] - 1) * $cfg['forum_message'], $cfg['forum_message'], TRUE);
        $params['theme'] = $messages['theme'];
        $content .= get_content('forum'.DS.'messages', $params);
    }
}

header('Content-type:text/html;charset=utf-8');
require_once DIR . DS . 'tpl' . DS . 'index.html';

# сортирует массив тем по времени написания последнего сообщения
function themes_time_sort($a, $b) {
    if ($a['ltime'] == $b['ltime']) return 0;
    return $a['ltime'] > $b['ltime'] ? -1 : 1;
}