<?php
/*
    ai — модель поведения
        0  — не движется (стоит на одном месте), всегда атакует игрока
        1  — случайным образом передвигается и атакует (1 из 3, что будет атака)
        2  — целенаправленно атакует игрока поблизости (2 из 3, что будет атака)
*/

$npc = array(

'zombie' => array(
    'name'          => 'Зомби',
    'type'          => 'monster',           # монстр — враждебен игроку
    'damage'        => array(3, 15),        # наносимые повреждения
    'noranged'      => 0,                   # если 1, то атакует только в текущей локации
    'delay'         => 5,                   # задержка между действиями
    'health'        => 20,                  # уровень здоровья
    'ai'            => 1,                   # модель поведения
    'items'         => array('i.mbullet'),  # что остаётся на трупе
),

'zombiesergeant' => array(
    'name'          => 'Зомби-сержант',
    'type'          => 'monster',
    'damage'        => array(9, 30),
    'noranged'      => 0,
    'delay'         => 4,
    'health'        => 30,
    'ai'            => 0,
    'items'         => array('g.gun2'),
),

'imp' => array(
    'name'          => 'Бес',
    'type'          => 'monster',
    'damage'        => array(3, 24),
    'noranged'      => 0,
    'delay'         => 4,
    'health'        => 60,
    'ai'            => 2,
    'items'         => array(),
),

);
