<?php
$map = array(
    'name'      => 'Убойный экшен',
    'desc'      => 'Простейшая карта. Нет дверей, много разнообразного оружия, масса патронов и аптечек. Рекомендуется для новичков.',
    'copy'      => 'Основана на последней карте первого эпизода Doom II',
    'time'      => 0, # время начала игры на данной карте
    'width'     => 8,
    'height'    => 7,
    'mapscale'  => 8,
    
    # точки входа
    'enter'     => array(
        array(4,1),
        array(6,3),
        array(4,5),
        array(2,3),
    ),
    
    # счёткий убийств (каждому новому трупу присваивается id = $map['frags'],
    # после чего содержимое данного элемента инкрементируется)
    'frags'     => 1,
    
    # счётчик монстров
    'monsters'  => 1,
    
    # список игроков
    'players'   => array(),
);


# ряд 0
$map[0][0] = array(
    'w' => array(0,1,0,0),
    'c' => array(),
    'i' => array(
        'g.gun7',
        'i.satchel',
        'i.bpower',
    ),
    'r' => array(
        array('g.gun7', 100, 0),
        array('i.satchel', 30, 0),
        array('i.bpower', 75, 0),
    ),
    'p' => array(),
    'n' => array(),
    'e' => 1
);
$map[1][0] = array(
    'w' => array(0,1,1,1),
    'c' => array(),
    'i' => array(
        'i.bbullet',
    ),
    'r' => array(
        array('i.bbullet', 35, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][0] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][0] = array(
    'w' => array(0,1,1,1),
    'c' => array(),
    'i' => array(
        'i.mrocket',
    ),
    'r' => array(
        array('i.mrocket', 10, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[4][0] = array(
    'w' => array(0,1,1,1),
    'c' => array(),
    'i' => array(
        'i.stimpack',
    ),
    'r' => array(
        array('i.stimpack', 25, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[5][0] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(
        'i.lightvest',
    ),
    'r' => array(
        array('i.lightvest', 30, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[6][0] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(
        'i.mshot',
    ),
    'r' => array(
        array('i.mshot', 30, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[7][0] = array(
    'w' => array(0,0,1,1),
    'c' => array(),
    'i' => array(
        'i.mshot',
    ),
    'r' => array(
        array('i.bshot', 35, 0),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 1
$map[0][1] = array();
$map[1][1] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.mbullet',
    ),
    'r' => array(
        array('i.mbullet', 30, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][1] = array(
    'w' => array(0,1,1,0),
    'c' => array(),
    'i' => array(
        'i.firstaidkit',
    ),
    'r' => array(
        array('i.firstaidkit', 50, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[3][1] = array(
    'w' => array(1,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[4][1] = array(
    'w' => array(1,1,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[5][1] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[6][1] = array(
    'w' => array(0,0,1,1),
    'c' => array(),
    'i' => array(
        'i.heavyvest',
    ),
    'r' => array(
        array('i.heavyvest', 50, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[7][1] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);

# ряд 2
$map[0][2] = array();
$map[1][2] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.lightvest',
    ),
    'r' => array(
        array('i.lightvest', 30, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][2] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][2] = array(
    'w' => array(0,1,1,0),
    'c' => array(),
    'i' => array(
        'g.gun5',
        'i.mrocket',
    ),
    'r' => array(
        array('g.gun5', 1, 0),
        array('i.mrocket', 10, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[4][2] = array(
    'w' => array(1,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[5][2] = array(
    'w' => array(0,0,1,1),
    'c' => array(),
    'i' => array(
        'g.gun6',
    ),
    'r' => array(
        array('g.gun6', 1, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[6][2] = array(
    'w' => array(1,1,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[7][2] = array(
    'w' => array(1,0,1,1),
    'c' => array(),
    'i' => array(
        'i.mrocket',
    ),
    'r' => array(
        array('i.mrocket', 10, 0),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 3
$map[0][3] = array();
$map[1][3] = array(
    'w' => array(1,1,1,0),
    'c' => array(),
    'i' => array(
        'i.stimpack',
    ),
    'r' => array(
        array('i.stimpack', 25, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][3] = array(
    'w' => array(1,1,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][3] = array(
    'w' => array(1,0,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[4][3] = array();
$map[5][3] = array(
    'w' => array(1,1,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[6][3] = array(
    'w' => array(1,1,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[7][3] = array(
    'w' => array(1,0,1,1),
    'c' => array(),
    'i' => array(
        'i.stimpack',
    ),
    'r' => array(
        array('i.stimpack', 25, 0),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 4
$map[0][4] = array();
$map[1][4] = array(
    'w' => array(1,1,1,0),
    'c' => array(),
    'i' => array(
        'i.mrocket',
    ),
    'r' => array(
        array('i.mrocket', 10, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][4] = array(
    'w' => array(1,0,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][4] = array(
    'w' => array(1,1,0,0),
    'c' => array(),
    'i' => array(
        'g.gun3',
    ),
    'r' => array(
        array('g.gun3', 1, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[4][4] = array(
    'w' => array(0,1,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[5][4] = array(
    'w' => array(1,0,0,1),
    'c' => array(),
    'i' => array(
        'g.gun4',
    ),
    'r' => array(
        array('g.gun4', 1, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[6][4] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[7][4] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.lightvest',
    ),
    'r' => array(
        array('i.lightvest', 30, 0),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 5
$map[0][5] = array();
$map[1][5] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.mshot',
    ),
    'r' => array(
        array('i.mshot', 15, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][5] = array(
    'w' => array(1,1,0,0),
    'c' => array(),
    'i' => array(
        'i.heavyvest',
    ),
    'r' => array(
        array('i.heavyvest', 50, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[3][5] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[4][5] = array(
    'w' => array(1,1,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[5][5] = array(
    'w' => array(0,1,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[6][5] = array(
    'w' => array(1,0,0,1),
    'c' => array(),
    'i' => array(
        'i.firstaidkit',
    ),
    'r' => array(
        array('i.firstaidkit', 50, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[7][5] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.mrocket',
    ),
    'r' => array(
        array('i.mrocket', 15, 0),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 6
$map[0][6] = array();
$map[1][6] = array(
    'w' => array(1,1,0,0),
    'c' => array(),
    'i' => array(
        'i.bpower',
    ),
    'r' => array(
        array('i.bpower', 40, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][6] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(
        'i.mpower',
    ),
    'r' => array(
        array('i.bpower', 30, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[3][6] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(
        'i.lightvest',
    ),
    'r' => array(
        array('i.lightvest', 30, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[4][6] = array(
    'w' => array(1,1,0,1),
    'c' => array(),
    'i' => array(
        'i.stimpack',
    ),
    'r' => array(
        array('i.stimpack', 25, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[5][6] = array(
    'w' => array(1,1,0,1),
    'c' => array(),
    'i' => array(
        'i.mrocket',
    ),
    'r' => array(
        array('i.mrocket', 10, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[6][6] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[7][6] = array(
    'w' => array(1,0,0,1),
    'c' => array(),
    'i' => array(
        'i.brocket',
    ),
    'r' => array(
        array('i.brocket', 25, 0),
    ),
    'p' => array(),
    'n' => array()
);

# двери (проверят для каждой локации посредством isset: $map['doors'][x+0.5][y],[x-0.5][y],[x][y+0.5],[x][y-0.5])
$map['doors']['0.5'][0] = array(
    'Дверь',    # название
    0,          # тип (0 - обычная дверь, 1 - для открытия нужен красный ключ, 2 - синий, 3 - жёлтый)
    0,          # текущее положение (закрыта)
    15,         # время возврата в умолчательное состояние
    0,          # время последней активации
);
