<?php
require 'header.php';

# если пользователь авторизован
if ( ! empty($_SESSION[SESNAME]['name'])) {
    # если юзер находится на карте, перебрасываем
    if (isset($_SESSION[SESNAME]['map'])) {
        header('Location: game.php?' . SESNAME . '=' . SESID);
        exit;
    }
    
/*
$user    = new user;
$user->login = 'admin';
$user->name = 'Админ';
file_put_contents(USER . 'admin.dat', serialize($user));
*/
    $game   = array(); # массив мира
    if ( ! file_exists(USERS . $_SESSION[SESNAME]['name'] . '.dat')) {
        header('Location: ?unlogin');
        exit;
    }
    $user   = unserialize(file_get_contents(USERS . $_SESSION[SESNAME]['name'] . '.dat'));
    
    # если пользователь на карте, перебросим его туда
    if ( ! empty($user->session)) {
        $_SESSION[SESNAME]['map']  = $user->session['map'];
        $_SESSION[SESNAME]['file'] = $user->session['file'];
        
        header('Location: game.php?' . SESNAME . '=' . SESID);
        exit;
    }
    
    if (empty($_GET) || isset($_GET[SESNAME])) $content = get_content();
    else {
        if (isset($_GET['profile'])) {
            $title          = 'Профиль';
            $params['user'] = $user;
            $content        = get_content('profile', $params);
        } elseif (isset($_GET['combat'])) {
            if (empty($_GET['info'])) {
                $params['tgame'] = array();
                $params['tmaps'] = array();
                # если время вышло, создаём
                #if (ITIME - fileatime(GAME . 'gamelist.txt') > 300) {
                    $s = '';
                    foreach (glob(GAME . '*.dat') as $game_file_name) {
                        $map = unserialize(file_get_contents($game_file_name));
                        
                        # сохраним игроков, не проявивших активность более 10 мин
                        if ($map['players']) foreach ($map['players'] as $name => $puser) {
                            if (ATIME - $puser->time > $cfg['user_active']) {
                                if ( ! empty($puser->loc)) {
                                    list($x, $y) = $puser->loc;
                                    unset($map[$x][$y]['c'][$name]);
                                }
                                
                                $puser->save_state();
                                unset($map['players'][$name]);
                            }
                        }
                        
                        # если никто не играет, очистить
                        if (empty($map['players'])) unlink($game_file_name);
                        else {
                            preg_match('/([a-zA-Z0-9_-]+)\.dat$/', $game_file_name, $t);
                            $file_name = $t[1];
                            $s .= $file_name.'|=-=|'.$map['name'].'|=-=|'.ITIME.'|=-=|'.count($map['players'])."\n";
                        }
                    }
                    file_put_contents(GAME . 'gamelist.txt', $s);
                #}
                
                foreach (file(GAME . 'gamelist.txt') as $mapfile) {
                    $mapfile = trim($mapfile);
                    if (empty($mapfile)) continue;
                    $params['tgame'][] = explode('|=-=|', $mapfile);
                }
                
                foreach (file(MAPS . 'maplist.txt') as $mapfile) {
                    $mapfile = trim($mapfile);
                    if (empty($mapfile)) continue;
                    $params['tmaps'][] = explode('=', $mapfile);
                }
                
                $content = get_content('combat', $params);
            } else {
                $params['map'] = array();
                $map_name = preg_replace('/\/\\\\\./', '', $_GET['info']);
                $map_file = MAPS . $map_name . '.php';
                if (file_exists($map_file)) {
                    include $map_file;
                    $map['file'] = $map_name;
                    $params['map'] =& $map;
                }
                $content = get_content('combat_info', $params);
            }
        } elseif (isset($_GET['createmap'])) {
            $_GET['createmap'] = preg_replace('/\/\\\\\./', '', $_GET['createmap']);
            $createmap_file = MAPS . $_GET['createmap'] . '.php';
            if (file_exists($createmap_file)) {
                $name = $_GET['createmap'] . '_' . SESID;
                $file = GAME . $name . '.dat';
                
                # если игровой файл с текущей картой существует
                if (file_exists($file)) { # подключаемся
                    $fileg = fopen($file, 'r+');
                    flock($fileg, LOCK_EX);
                    $map = unserialize(fread($fileg, filesize($file)));
                    $map['players'][$user->login] = $user;
                    fseek($fileg, 0);
                    ftruncate($fileg, 0);
                    fwrite($fileg, serialize($map));
                    flock($fileg, LOCK_UN);
                    fclose($fileg);
                } else {
                    require_once $createmap_file;
                    $map['players'][$user->login] = $user;
                    file_put_contents($file, serialize($map));
                    file_put_contents(GAME . 'gamelist.txt', $name.'|=-=|'.$map['name'].'|=-=|'.ITIME.'|=-=|1');
                }
                $_SESSION[SESNAME]['map']  = $_GET['createmap'];
                $_SESSION[SESNAME]['file'] = $file;
                
                $user->session['map']  = $_SESSION[SESNAME]['map'];
                $user->session['file'] = $_SESSION[SESNAME]['file'];
                $user->save_state(FALSE);
                
                header('Location: game.php?' . SESNAME . '=' . SESID);
                exit;
            } else $content = get_content('nomap');
        } elseif (isset($_GET['connect'])) {
            $_GET['connect'] = preg_replace('/\/\\\\\./', '', $_GET['connect']);
            $name = $_GET['connect'];
            $file = GAME . $name . '.dat';
            
            if (file_exists($file)) {
                # если игровой файл с текущей картой существует, подключаемся
                $fileg = fopen($file, 'r+');
                flock($fileg, LOCK_EX);
                $map = unserialize(fread($fileg, filesize($file)));
                $map['players'][$user->login] = $user;
                fseek($fileg, 0);
                ftruncate($fileg, 0);
                fwrite($fileg, serialize($map));
                flock($fileg, LOCK_UN);
                fclose($fileg);
                
                $_SESSION[SESNAME]['map']  = substr($name, 0, 0 - strlen(SESID) - 1);
                $_SESSION[SESNAME]['file'] = $file;
                
                $user->session['map']  = $_SESSION[SESNAME]['map'];
                $user->session['file'] = $_SESSION[SESNAME]['file'];
                $user->save_state(FALSE);
                
                header('Location: game.php?' . SESNAME . '=' . SESID);
                exit;
            } else $content = get_content('nomap');
        } elseif (isset($_GET['gm'])) {
            /*if (file_exists(GAME . 'map0001.dat')) {
                $game = unserialize(file_get_contents(GAME . 'map0001.dat'));
            }*/
            require_once MAPS . 'map0001.php';
            
        } elseif (isset($_GET['unlogin'])) {
            session_destroy();
            $_SESSION[SESNAME] = array();
            header('Location: ?' . rand());
            exit;
        } else $content = get_content();
    }
} else { # иначе предлагаем авторизоваться/зарегистрироваться
    
    if (isset($_GET['reg'])) {
        if ( ! empty($_POST)) {
            if (isset($_POST['l'])) {
                if ( ! preg_match('/^[a-z0-9]{4,10}$/', strtolower($_POST['l']))) {
                    $err['l'] = 'Логин содержит недопустимые символы';
                    $_POST['l'] = preg_replace('/[^a-z0-9]{4,10}/', '', strtolower($_POST['l']));
                }
                if (strlen($_POST['l']) < 4) $err['l'] = 'Слишком короткий логин';
                if (file_exists(USERS . $_POST['l'] . '.dat')) $err['l'] = 'Пользователь с указанным логином уже зарегистрирован';
            }
            
            if (isset($_POST['p'])) {
                if ($_POST['p'] === '') {
                    $err['p'] = 'поле должно быть заполнено';
                    unset($_POST['p']);
                }
            }
            
            if ( ! empty($_POST['e'])) {
                $_POST['e'] = strtolower(trim($_POST['e']));
                if ( ! preg_match('!^[a-z0-9\._-]{2,}@[a-z0-9][a-z0-9\.-]{4,}$!', $_POST['e'])) {
                    $err['e'] = 'некорректный адрес';
                    $_POST['e'] = htmlspecialchars($_POST['e']);
                }
            }
        }
        if (isset($err)) $params['err'] = $err;
        
        # если пользователь хочет зарегистрироваться или ввёл неправильные данные — форма для регистрации
        if ((isset($err) && ! empty($_POST)) || empty($_POST)) {
            $content = get_content('reg', $params);
        } else { # иначе создать новую запись
            $newuser = new user;
            $newuser->login = $_POST['l'];
            $newuser->name  = $_POST['l'];
            $newuser->mail  = $_POST['e'];
            $newuser->pass  = base64_encode($_POST['p']);
            file_put_contents(USERS . $_POST['l'] . '.dat', serialize($newuser));
            
            $params['user']  = $_POST['l'];
            $params['pass']  = htmlspecialchars($_POST['p']);
            $params['cpass'] = rawurlencode($_POST['p']);
            
            $content = get_content('reg_true', $params);
        }
    } elseif (isset($_GET['in'])) {
        if (isset($_GET['l']) && isset($_GET['p'])) {
            if (isset($_GET['l'])) {
                if ( ! preg_match('/^[a-z0-9]{4,10}$/', strtolower($_GET['l']))) {
                    $err['l'] = 'Логин содержит недопустимые символы';
                    $_GET['l'] = preg_replace('/[^a-z0-9]{4,10}/', '', strtolower($_GET['l']));
                }
                if (strlen($_GET['l']) < 4) $err = 1;
                if ( ! file_exists(USERS . $_GET['l'] . '.dat')) $err = 2;
            }
            
            if (isset($_GET['p'])) {
                if ($_GET['p'] === '') {
                    $err = 3;
                    unset($_GET['p']);
                }
            }
            
            if (empty($err)) {
                if (file_exists(USERS . $_GET['l'] . '.dat')) {
                    $testuser = new user;
                    $testuser = unserialize(file_get_contents(USERS . $_GET['l'] . '.dat'));
                    if ($_GET['p'] !== base64_decode($testuser->pass)) $err = 5;
                } else $err = 4;
            }
        }
        if (isset($err)) $params['err'] = $err;
        
        # если пользователь ввёл неправильные данные — форма для входа
        if (isset($err)) {
            $content = get_content('in', $params);
        } else { # иначе, осуществляем вход
            # обязательно при авторизации требуется новый id-сессии
            $id = md5(rand() . microtime());
            
            setcookie(SESNAME, $id);
            $_COOKIE[SESNAME] = $id;
            $_GET[SESNAME] = $id;
            $_POST[SESNAME] = $id;
            
            session_name(SESNAME);
            session_id($id);
            session_start();
            
            $_SESSION[SESNAME]['name'] = $_GET['l'];
            header('Location: ?' . SESNAME . '=' . session_id());
            exit;
        }
    } else $content = get_content('in');
}

header('Content-type:text/html;charset=utf-8');
require_once DIR . DS . 'tpl' . DS . 'index.html';

echo '<!-- '.round(microtime(1) - ATIME, 4).' -->';
